#ifndef _H_MORPH_LOG
#define _H_MORPH_LOG

#include <loc.h>

typedef enum log_level_e {
    ERROR,
    WARN,
    INFO,
    DEBUG,
} log_level_t;

void _log(loc_t* loc, log_level_t level, const char* fmt, ...);

#define log_error(loc, ...) _log(loc, ERROR, __VA_ARGS__)
#define log_warn(loc, ...) _log(loc, WARN, __VA_ARGS__)
#define log_info(loc, ...) _log(loc, INFO, __VA_ARGS__)
#define log_debug(loc, ...) _log(loc, DEBUG, __VA_ARGS__)

#endif // !_H_MORPH_LOG
